#include <16F628.h>

#use delay(clock=4000000)

#fuses INTRC_IO,NOBROWNOUT,PROTECT,NOCPD,NOLVP,WDT,MCLR,NOPUT


#define ONE_WIRE_PIN PIN_A1
#include "DS1822.C"

//#include "fonts3x5.h"

#define    sutun1      PIN_A2
#define    sutun2      PIN_A3
#define    sutun3      PIN_A0
#define    sutun4      PIN_A7
#define    sutun5      PIN_A6

#define    DS1822_PWR  PIN_B7  

#define    modtus      PIN_A5

#define    TONE_PIN    PIN_A4

#define    solduy    !input(PIN_A2)
#define    sagduy    !input(PIN_A1)

#define    up    -1
#define    down   1
#define    left  -1
#define    right  1

#define    ekrON  2

int ekran[6]={0xff,0xff,0xff,0xff,0xff,0xff};
int depo [6]={0xff,0xff,0xff,0xff,0xff,0xff};

//                         E   n   d   t   a   s
int32 const mesaj1=0b11111100011111110110111111100111;
int32 const mesaj2=0b11111101111111110110111111011111;
int32 const mesaj3=0b11111100110011100100011001001111;
int32 const mesaj4=0b11111101110101010110110101110111;
int32 const mesaj5=0b11111100010101100110011001001111;

//int ekransay;

signed int temperature, eskitemp;


//************************************************
void efektpin(int sayac,int kere){
int depo;

depo = kere;

      output_high(TONE_PIN);
          for(;kere>0;kere--)      delay_us(sayac);
      output_low(TONE_PIN);
      kere = depo;
          for(;kere>0;kere--)      delay_us(sayac);
}
//************************************************
void ciuv(int tekrar, int frqrange, int1 yon, int frek){

int sayac,depo;

 while((tekrar--) != 0)
 {
   if(yon){
    for(sayac=1;sayac<frqrange;sayac++)
      {
      efektpin(sayac,frek);
      }
   }
   else {
   for(sayac=frqrange;sayac>0;sayac--)
      {
      efektpin(sayac,frek);
      }
   }
 }
 depo = input(tone_pin);
}
//-----------------------------------------
void bekle(int16 period){
   while(period > 0)
   {
      period--;
      delay_ms(1);
   }
}
//----------------------------------------
birsay(int giris){
int a, yananled = 0;
   for (a=0 ; a<8 ; a++){
      if( bit_test (giris, a) == 0 ) yananled ++;
   }
   return yananled;
}
//----------------------------------------
void ekran_tara()
{

   output_b (ekran[1]);
   output_high(sutun1);
   delay_ms(ekrON+birsay(ekran[1]));
   output_low(sutun1);

   output_b (ekran[2]);
   output_high(sutun2);
   delay_ms(ekrON+birsay(ekran[2]));
   output_low(sutun2);

   output_b (ekran[3]);
   output_high(sutun3);
   delay_ms(ekrON+birsay(ekran[3]));
   output_low(sutun3);

   output_b (ekran[4]);
   output_high(sutun4);
   delay_ms(ekrON+birsay(ekran[4]));
   output_low(sutun4);

   output_b (ekran[5]);
   output_high(sutun5);
   delay_ms(ekrON+birsay(ekran[5]));
   output_low(sutun5);

}
//-----------------------------------------
void pixbas(int x, int y){
ekran[1] = 0b11111111;
ekran[2] = 0b11111111;
ekran[3] = 0b11111111;
ekran[4] = 0b11111111;
ekran[5] = 0b11111111;

bit_clear(ekran[y], 7-x);
}
//-----------------------------------------
void pingpong(){
int yonx=right, yony= down;
int  sayac=30, x=2, y=1;

   while(!onewire_init_with_error_check()){
      //period-->
      restart_wdt();
      ekran_tara();
      sayac--;
   if(sayac==0){
      sayac = 10;
      
      x = x + yonx;
      if (x == 7 || x==1 ) { yonx = -yonx; ciuv(1,30,0,1);}
      y = y + yony;
      if (y == 5 || y==1 ) { yony = -yony; ciuv(1,30,0,1);}
      pixbas(x,y);
   }
   }
}
//----------------------------------------
void harfbak(int harf){
int depot;


depot = harf;
harf = harf & 0b00001111;

switch (harf) {
   case 0:
      depo[1] = 0b00001101;
      depo[2] = 0b00001010;
      depo[3] = 0b00001010;
      depo[4] = 0b00001010;
      depo[5] = 0b00001101;
   break;
   case 1:
      depo[1] = 0b00001101;
      depo[2] = 0b00001001;
      depo[3] = 0b00001101;
      depo[4] = 0b00001101;
      depo[5] = 0b00001000;   
   break;
   case 2:
      depo[1] = 0b00001001;
      depo[2] = 0b00001110;
      depo[3] = 0b00001101;
      depo[4] = 0b00001011;
      depo[5] = 0b00001000;   
   break;
   case 3:
      depo[1] = 0b00001001;
      depo[2] = 0b00001110;
      depo[3] = 0b00001101;
      depo[4] = 0b00001110;
      depo[5] = 0b00001001;   
   break;
   case 4:
      depo[1] = 0b00001101;
      depo[2] = 0b00001001;
      depo[3] = 0b00001000;
      depo[4] = 0b00001101;
      depo[5] = 0b00001101;   
   break;
   case 5:
      depo[1] = 0b00001000;
      depo[2] = 0b00001011;
      depo[3] = 0b00001001;
      depo[4] = 0b00001110;
      depo[5] = 0b00001001;   
   break;
   case 6:
      depo[1] = 0b00001100;
      depo[2] = 0b00001011;
      depo[3] = 0b00001001;
      depo[4] = 0b00001010;
      depo[5] = 0b00001101;   
   break;
   case 7:
      depo[1] = 0b00001000;
      depo[2] = 0b00001110;
      depo[3] = 0b00001101;
      depo[4] = 0b00001101;
      depo[5] = 0b00001101;   
   break;
   case 8:
      depo[1] = 0b00001000;
      depo[2] = 0b00001010;
      depo[3] = 0b00001101;
      depo[4] = 0b00001010;
      depo[5] = 0b00001000;   
   break;
   case 9:
      depo[1] = 0b00001101;
      depo[2] = 0b00001010;
      depo[3] = 0b00001100;
      depo[4] = 0b00001110;
      depo[5] = 0b00001101;   
   break;   
   default:
      depo[1] = 0b01111111;
      depo[2] = 0b01111111;
      depo[3] = 0b01111111;
      depo[4] = 0b01111111;
      depo[5] = 0b01111111;   
   
   break; }

}
/////////////////////////////////////////////////////
void kaydir(){

int32 m1 = mesaj1, m2=mesaj2, m3=mesaj3, m4=mesaj4, m5=mesaj5;
static int say=6, kere=50;
int kayma=26;

while(kere!=0){
kere--;
kayma--;
if (kayma!=0){
   kayma--;
   ekran[1] = (m1>>kayma) ;
   ekran[2] = (m2>>kayma) ;
   ekran[3] = (m3>>kayma) ;
   ekran[4] = (m4>>kayma) ;
   ekran[5] = (m5>>kayma) ;
}
else{
   if(say-- >0){
      ekran[1] = ekran[1]<<1 | 0b00000001;
      ekran[2] = ekran[2]<<1 | 0b00000001;
      ekran[3] = ekran[3]<<1 | 0b00000001;
      ekran[4] = ekran[4]<<1 | 0b00000001;
      ekran[5] = ekran[5]<<1 | 0b00000001;
   }
   else { kayma= 26; say=6;}
}
}
}
/////////////////////////////////////////////////////

void temp( ){
int onlar=0, birler=0;
//int16 a;
output_high(DS1822_PWR);
ciuv(1,10,0,1);

pingpong();
/*
a=100;

while (a!=0) {
   restart_wdt();
   //ekran_tara();
   a--;
}


   while (!onewire_init_with_error_check()){
   restart_wdt();
   ekran_tara();
   }*/
     //if( onewire_init_with_error_check() ){
         onewire_ds1822_set_temperature_resolution(9); 
         temperature = onewire_ds1822_read_temp_c_lite();   // Returns only + temps
     //}
     /*else{
         output_low(DS1822_PWR);
         output_low(ONE_WIRE_PIN);
         //pingpong(1000);
         while(TRUE);
     }*/

if( temperature != eskitemp){
eskitemp = temperature;
  while(temperature >= 10) {
      temperature -= 10;
      onlar++;
  }    
  //restart_wdt();
  
  while(temperature >= 1) {
      temperature --;
      birler++;
  }    
 if(onlar != 0){ 
   harfbak(onlar);
   ekran [1] = (depo [1]<<4) & 0b01111111;
   ekran [2] = (depo [2]<<4) & 0b01111111;
   ekran [3] = (depo [3]<<4) & 0b01111111;
   ekran [4] = (depo [4]<<4) & 0b01111111;
   ekran [5] = (depo [5]<<4) & 0b01111111;
 }
 else  {
   ekran [1] = 0b01110000;
   ekran [2] = 0b01110000;
   ekran [3] = 0b01110000;
   ekran [4] = 0b01110000;
   ekran [5] = 0b01110000;
 }
   harfbak(birler);
   ekran [1] |= depo [1] & 0b00001111;
   ekran [2] |= depo [2] & 0b00001111;
   ekran [3] |= depo [3] & 0b00001111;
   ekran [4] |= depo [4] & 0b00001111;
   ekran [5] |= depo [5] & 0b00001111;
}

  
}

/////////////////////////////////////////////////////

void main ( )
{

int16 sayac;
output_high(DS1822_PWR);
setup_comparator (NC_NC_NC_NC);
SETUP_WDT (WDT_2304MS);

ekran[1]=0xbe;
ekran[2]=0xff;
ekran[3]=0xff;
ekran[4]=0xff;
ekran[5]=0xbe;



//ciuv(1,155,0,1);

//kaydir(); 

//pingpong(10000);
//delay_ms(1000);
sayac = 50;

while(TRUE){
restart_wdt();
if(sayac--  == 0) { temp(); sayac =500; }

ekran_tara();



}
}
